Gauge annotations in JavaScript Circular gauge control

18 Nov 201819 minutes to read

Annotations are used to mark a specific area of interest in the gauge with texts, shapes or images.

Content

You can place any custom element on the axis area by assigning the id of the element to content property of annotation object.

Note: To use annotation feature, we need to inject Annotations module using CircularGauge.Inject(Annotations) method.

var circulargauge = new ej.circulargauge.CircularGauge({
    axes: [{
        annotations: [{
            content: 'annotation-template',
             zIndex:'1'
        }],
        pointers:[{
            value: 50
        }]
    }]
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/material.css" rel="stylesheet">
    
    
    <script id="annotation-template" type="text/x-template">
        <div id='templateWrap'>
            <div class='des'>
                <span>Pointer Value : 50</span>
            </div>
        </div>
    </script>
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Position

Annotation can be placed around the axis by using radius and angle property.
For example, if the angle is 90 degree and the radius is 110%, then the annotation, will be placed at the right side of the axis.

Radius of the annotation takes value either in pixel or percentage. By setting value in percentage, annotation gets its position with respect to its axis radius.

var circulargauge = new ej.circulargauge.CircularGauge({
    axes: [{
        annotations: [{
            content: '#annotation-template',
            angle: 90,
            radius: '150%',
            zIndex:'1'
        }],
        pointers:[{
            value: 50
        }]
    }]
}, '#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/material.css" rel="stylesheet">
    
    
    <script id="annotation-template" type="text/x-template">
        <div id='templateWrap'>
            <div class='des'>
                <span>Pointer Value : 50</span>
            </div>
        </div>
    </script>
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Sub Gauge

As the annotation allows you to place any custom element, we can initialize a gauge to the element and can be used to place that in another gauge.

var circulargauge = new ej.circulargauge.CircularGauge({
    axes: [{
        minimum: 0,
        maximum: 12,
        startAngle: 0,
        endAngle: 360,
        lineStyle: { width: 0 },
        ranges: [
            {
                start: 0, end: 3,
                color: 'rgba(29,29,29,0.7)'
            }, {
                start: 3, end: 12,
                color: 'rgba(168,145,102,0.1)'
            }
        ],
        annotations: [{
            angle: 270,
            radius: '40%',
            content: '<div id="subGauge" style="width:90px;height:90px;"></div>'
        },{
            angle: 90,
            radius: '40%',
            content: '<div id="time"><span>6:30 PM</span></div>'
        }],
        labelStyle: {
            hiddenLabel: 'First'
        },
        pointers: [{
            pointerWidth: 5,
            radius: '40%',
            value: 6.5,
            color: 'rgb(29,29,29)',
            border: { width: 1, color: 'rgb(29,29,29)' },
            cap: {
                color: 'rgb(29,29,29)',
                radius: 0,
                border: {
                    width: 0.2,
                    color: 'red'
                }
            },
            needleTail: {
                length: '0%'
            }, animation: {
                enable: false
            }
        }, {
            radius: '60%',
            pointerWidth: 5,
            color: 'rgb(29,29,29)',
            border: {
                width: 1,
                color: 'rgb(29,29,29)'
            },
            value: 6,
            cap: {
                color: 'rgb(29,29,29)',
                radius: 0,
                border: {
                    width: 0.2,
                    color: 'red'
                }
            },
            needleTail: {
                length: '0%'
            }, animation: {
                enable: false
            }
        }, {
            radius: '70%',
            pointerWidth: 4,
            value: 9.8,
            color: 'rgba(168,145,102,1)',
            cap: {
                color: 'rgba(168,145,102,1)',
                radius: 4,
                border: {
                    width: 0.2,
                    color: 'rgba(168,145,102,1)'
                }
            },
            needleTail: {
                color: 'rgba(168,145,102,1)',
                length: '20%'
            }, animation: {
                enable: false,
                duration: 500
            }
        }]
    }]
}, '#element');

var circulargauge = new ej.circulargauge.CircularGauge({
    axes: [{
        minimum: 0,
        maximum: 12,
        startAngle: 0,
        endAngle: 360,
        majorTicks:{
            interval: 3
        },
        lineStyle: { width: 0 },
        ranges: [
            {
                start: 0, end: 3,
                startWidth: 5, endWidth: 5,
                color: 'rgba(29,29,29,0.7)'
            }, {
                start: 3, end: 12,
                startWidth: 5, endWidth: 5,
                color: 'rgba(168,145,102,0.1)'
            }
        ],
        labelStyle: {
            hiddenLabel: 'First',
            offset: -5
        },
        pointers: [{
            pointerWidth: 2,
            radius: '40%',
            color: 'rgb(29,29,29)',
            border: { width: 1, color: 'rgb(29,29,29)' },
            cap: {
                color: 'rgb(29,29,29)',
                radius: 2,
                border: {
                    width: 0.2,
                    color: 'red'
                }
            },
            needleTail: {
                length: '0%'
            }, animation: {
                enable: false
            }
        }]
    }]
}, '#subGauge');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/material.css" rel="stylesheet">
    
    
    <script id="annotation-template" type="text/x-template">
        <div id='templateWrap'>
            <div class='des'>
                <span>Pointer Value : 50</span>
            </div>
        </div>
    </script>
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

See also

Gauge annotations in Vue Circular gauge component

18 Nov 201824 minutes to read

Annotations are used to mark a specific area of interest in the gauge with texts, shapes or images.

Content

You can place any custom element on the axis area by assigning the id of the element to
content property of annotation object.

Note: To use annotation feature, we need to inject Annotations module using CircularGauge.Inject(Annotations) method.

<template>
    <div id="app">
        <div class='wrapper'>
            <ejs-circulargauge>
                <e-axes>
                    <e-axis :annotations='annotations'>
                        <e-pointers>
                            <e-pointer value=50></e-pointer>
                        </e-pointers>
                    </e-axis>
                </e-axes>
            </ejs-circulargauge>
        </div>
    </div>
  </template>
  <script setup>
  import { provide, createApp } from "vue";
  import { CircularGaugeComponent as EjsCirculargauge, AxesDirective as EAxes, AxisDirective as EAxis, PointersDirective as EPointers, PointerDirective as EPointer, Annotations } from "@syncfusion/ej2-vue-circulargauge";
  
  let contentVue = createApp().component("contentTemplate", {
    template: '<div><span style="font-size:10px; color:#424242; font-family:Regular">pointer Value: 50</span></div>',
    data() {
        return {
            data: {}
        };
    }
  });
  
  let contentTemplate = function () {
    return { template: contentVue };
  };
  
  const annotations = [{
    content: contentTemplate,
    zIndex: '1'
  }]
  
  provide('circulargauge', [Annotations]);
  
  </script>
  <style>
  .wrapper {
    max-width: 300px;
    margin: 0 auto;
  }
  </style>
<template>
    <div id="app">
        <div class='wrapper'>
            <ejs-circulargauge>
                <e-axes>
                    <e-axis :annotations='annotations'>
                        <e-pointers>
                            <e-pointer value=50></e-pointer>
                        </e-pointers>
                    </e-axis>
                </e-axes>
            </ejs-circulargauge>
        </div>
    </div>
</template>
<script>
import { createApp } from  "vue";
import { CircularGaugeComponent, AxesDirective, AxisDirective, PointerDirective, PointersDirective, Annotations } from "@syncfusion/ej2-vue-circulargauge";

let contentVue = createApp().component("contentTemplate", {
    template: '<div><span style="font-size:10px; color:#424242; font-family:Regular">pointer Value: 50</span></div>',
    data() {
        return {
            data: {}
        };
    }
});
let contentTemplate = function () {
    return { template: contentVue };
};

export default {
    name: "App",
    components: {
        "ejs-circulargauge": CircularGaugeComponent,
        "e-axes": AxesDirective,
        "e-axis": AxisDirective,
        "e-pointers": PointersDirective,
        "e-pointer": PointerDirective
    },

    data: function () {
        return {
            annotations: [{
                content: contentTemplate,
                zIndex: '1'
            }]
        }
    },
    provide: {
        circulargauge: [Annotations]
    }
};
</script>
<style>
.wrapper {
    max-width: 300px;
    margin: 0 auto;
}
</style>

Position

Annotation can be placed around the axis by using radius
and angle property.
For example, if the angle is 90 degree and the radius is 110%, then the annotation, will be placed at the right side of the axis.

Radius of the annotation takes value either in pixel or percentage. By setting value in percentage, annotation gets its position with respect to its axis radius.

<template>
    <div id="app">
        <div class='wrapper'>
            <ejs-circulargauge>
                <e-axes>
                    <e-axis :annotations='annotations'>
                        <e-pointers>
                            <e-pointer value=50></e-pointer>
                        </e-pointers>
                    </e-axis>
                </e-axes>
            </ejs-circulargauge>
        </div>
    </div>
</template>
<script setup>
import { provide, createApp } from "vue";
import { CircularGaugeComponent as EjsCirculargauge, AxesDirective as EAxes, AxisDirective as EAxis, PointersDirective as EPointers, PointerDirective as EPointer, Annotations } from "@syncfusion/ej2-vue-circulargauge";

let contentVue = createApp().component("contentTemplate", {
    template: '<div><span style="font-size:10px; color:#424242; font-family:Regular">pointer Value: 50</span></div>',
    data() {
        return {
            data: {}
        };
    }
});
let contentTemplate = function () {
    return { template: contentVue };
};

const annotations = [{
    content: contentTemplate,
    angle: 90,
    radius: '150%',
    zIndex: '1'
}]

provide('circulargauge', [Annotations]);

</script>
<style>
.wrapper {
    max-width: 300px;
    margin: 0 auto;
}
</style>
<template>
    <div id="app">
        <div class='wrapper'>
            <ejs-circulargauge>
                <e-axes>
                    <e-axis :annotations='annotations'>
                        <e-pointers>
                            <e-pointer value=50></e-pointer>
                        </e-pointers>
                    </e-axis>
                </e-axes>
            </ejs-circulargauge>
        </div>
    </div>
</template>
<script>
import { createApp } from "vue";
import { CircularGaugeComponent, AxesDirective, AxisDirective, PointerDirective, PointersDirective, Annotations } from "@syncfusion/ej2-vue-circulargauge";

let contentVue = createApp().component("contentTemplate", {
    template: '<div><span style="font-size:10px; color:#424242; font-family:Regular">pointer Value: 50</span></div>',
    data() {
        return {
            data: {}
        };
    }
});

let contentTemplate = function () {
    return { template: contentVue };
};

export default {
    name: "App",
    components: {
        "ejs-circulargauge": CircularGaugeComponent,
        "e-axes": AxesDirective,
        "e-axis": AxisDirective,
        "e-pointers": PointersDirective,
        "e-pointer": PointerDirective
    },
    data: function () {
        return {
            annotations: [{
                content: contentTemplate,
                angle: 90,
                radius: '150%',
                zIndex: '1'
            }]
        }
    },
    provide: {
        circulargauge: [Annotations]
    }
};
</script>
<style>
.wrapper {
    max-width: 300px;
    margin: 0 auto;
}
</style>

Sub Gauge

As the annotation allows you to place any custom element, we can initialize a gauge to the element and can
be used to place that in another gauge.

<template>
    <div id="app">
        <div class='wrapper'>
            <ejs-circulargauge :axes='axes'>
            </ejs-circulargauge>
        </div>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { CircularGaugeComponent, Annotations } from "@syncfusion/ej2-vue-circulargauge";


const axes = [{
    minimum: 0,
    maximum: 12,
    startAngle: 0,
    endAngle: 360,
    lineStyle: { width: 0 },
    ranges: [{
        start: 0, end: 3,
        color: 'rgba(29,29,29,0.7)'
    }, {
        start: 3, end: 12,
        color: 'rgba(168,145,102,0.1)'
    }],
    annotations: [{
        angle: 270,
        radius: '40%',
        content: '<div id="subGauge" style="width:90px;height:90px;"></div>'
    }, {
        angle: 90,
        radius: '40%',
        content: '<div id="time"><span>6:30 PM</span></div>',
        zIndex: '1'
    }],
    labelStyle: {
        hiddenLabel: 'First'
    },
    pointers: [{
        pointerWidth: 5,
        radius: '40%',
        value: 6.5,
        color: 'rgb(29,29,29)',
        border: { width: 1, color: 'rgb(29,29,29)' },
        cap: {
            color: 'rgb(29,29,29)',
            radius: 0,
            border: {
                width: 0.2,
                color: 'red'
            }
        },
        needleTail: {
            length: '0%'
        },
        animation: {
            enable: false
        }
    },
    {
        radius: '60%',
        pointerWidth: 5,
        color: 'rgb(29,29,29)',
        border: {
            width: 1,
            color: 'rgb(29,29,29)'
        },
        value: 6,
        cap: {
            color: 'rgb(29,29,29)',
            radius: 0,
            border: {
                width: 0.2,
                color: 'red'
            }
        },
        needleTail: {
            length: '0%'
        },
        animation: {
            enable: false
        }
    },
    {
        radius: '70%',
        pointerWidth: 4,
        value: 9.8,
        color: 'rgba(168,145,102,1)',
        cap: {
            color: 'rgba(168,145,102,1)',
            radius: 4,
            border: {
                width: 0.2,
                color: 'rgba(168,145,102,1)'
            }
        },
        needleTail: {
            color: 'rgba(168,145,102,1)',
            length: '20%'
        },
        animation: {
            enable: false,
            duration: 500
        }
    }]
}]

provide('circulargauge', [Annotations]);


</script>
<style>
.wrapper {
    max-width: 300px;
    margin: 0 auto;
}
</style>
<template>
    <div id="app">
        <div class='wrapper'>
            <ejs-circulargauge :axes='axes'>
            </ejs-circulargauge>
        </div>
    </div>
</template>
<script>

import { CircularGaugeComponent, Annotations } from "@syncfusion/ej2-vue-circulargauge";

export default {
    name: "App",
    components: {
        "ejs-circulargauge": CircularGaugeComponent
    },
    data: function () {
        return {
            axes: [{
                minimum: 0,
                maximum: 12,
                startAngle: 0,
                endAngle: 360,
                lineStyle: { width: 0 },
                ranges: [{
                    start: 0, end: 3,
                    color: 'rgba(29,29,29,0.7)'
                }, {
                    start: 3, end: 12,
                    color: 'rgba(168,145,102,0.1)'
                }],
                annotations: [{
                    angle: 270,
                    radius: '40%',
                    content: '<div id="subGauge" style="width:90px;height:90px;"></div>'
                }, {
                    angle: 90,
                    radius: '40%',
                    content: '<div id="time"><span>6:30 PM</span></div>',
                    zIndex: '1'
                }],
                labelStyle: {
                    hiddenLabel: 'First'
                },
                pointers: [{
                    pointerWidth: 5,
                    radius: '40%',
                    value: 6.5,
                    color: 'rgb(29,29,29)',
                    border: { width: 1, color: 'rgb(29,29,29)' },
                    cap: {
                        color: 'rgb(29,29,29)',
                        radius: 0,
                        border: {
                            width: 0.2,
                            color: 'red'
                        }
                    },
                    needleTail: {
                        length: '0%'
                    },
                    animation: {
                        enable: false
                    }
                },
                {
                    radius: '60%',
                    pointerWidth: 5,
                    color: 'rgb(29,29,29)',
                    border: {
                        width: 1,
                        color: 'rgb(29,29,29)'
                    },
                    value: 6,
                    cap: {
                        color: 'rgb(29,29,29)',
                        radius: 0,
                        border: {
                            width: 0.2,
                            color: 'red'
                        }
                    },
                    needleTail: {
                        length: '0%'
                    },
                    animation: {
                        enable: false
                    }
                },
                {
                    radius: '70%',
                    pointerWidth: 4,
                    value: 9.8,
                    color: 'rgba(168,145,102,1)',
                    cap: {
                        color: 'rgba(168,145,102,1)',
                        radius: 4,
                        border: {
                            width: 0.2,
                            color: 'rgba(168,145,102,1)'
                        }
                    },
                    needleTail: {
                        color: 'rgba(168,145,102,1)',
                        length: '20%'
                    },
                    animation: {
                        enable: false,
                        duration: 500
                    }
                }]
            }]
        }
    },
    provide: {
        circulargauge: [Annotations]
    }
};

</script>
<style>
.wrapper {
    max-width: 300px;
    margin: 0 auto;
}
</style>

See also

Gauge annotations in Angular Circular gauge component

18 Nov 201819 minutes to read

Annotations are used to mark a specific area of interest in the gauge with texts, shapes or images.

Content

You can place any custom element on the axis area by assigning the id of the element to content property of annotation object.

Note: To use annotation feature, we need to inject AnnotationsService into the NgModule.providers.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { CircularGaugeModule } from '@syncfusion/ej2-angular-circulargauge'
import { AnnotationsService } from '@syncfusion/ej2-angular-circulargauge'




import { Component, OnInit } from '@angular/core';

@Component({
imports: [
         CircularGaugeModule
    ],

providers: [AnnotationsService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-circulargauge id="circular-container">
        <e-axes>
            <e-axis>
                <e-pointers>
                    <e-pointer value = 50></e-pointer>
                </e-pointers>
                <e-annotations>
                    <e-annotation zIndex='1'>
						<ng-template #content>
							<div>
							  <div><span>Pointer Value : 50</span>
                              </div>
                            </div>
                        </ng-template>
                    </e-annotation>
                </e-annotations>
            </e-axis>
        </e-axes>
    </ejs-circulargauge>`
})
export class AppComponent implements OnInit {
    ngOnInit(): void {
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Position

Annotation can be placed around the axis by using radius and angle property.
For example, if the angle is 90 degree and the radius is 110%, then the annotation, will be placed at the right side of the axis.

Radius of the annotation takes value either in pixel or percentage.
By setting value in percentage, annotation gets its position with respect to its axis radius.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { CircularGaugeModule } from '@syncfusion/ej2-angular-circulargauge'
import { AnnotationsService } from '@syncfusion/ej2-angular-circulargauge'




import { Component, OnInit } from '@angular/core';

@Component({
imports: [
         CircularGaugeModule
    ],

providers: [AnnotationsService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-circulargauge id="circular-container">
        <e-axes>
            <e-axis>
                <e-pointers>
                    <e-pointer value = 50></e-pointer>
                </e-pointers>
                <e-annotations>
                    <e-annotation angle=90 radius="150%" zIndex="1">
						<ng-template #content>
							<div>
								<div><span>Pointer Value : 50</span>
                                </div>
                            </div>
                        </ng-template>
                    </e-annotation>
                </e-annotations>
            </e-axis>
        </e-axes>
    </ejs-circulargauge>`
})
export class AppComponent implements OnInit {
    ngOnInit(): void {
        // Initialize objects
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Sub Gauge

As the annotation allows you to place any custom element, we can initialize a gauge to the element and can be used to place that in another gauge.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { CircularGaugeModule } from '@syncfusion/ej2-angular-circulargauge'
import { AnnotationsService } from '@syncfusion/ej2-angular-circulargauge'




import { Component, OnInit } from '@angular/core';
import { CircularGauge } from '@syncfusion/ej2-angular-circulargauge';
import { ILoadedEventArgs } from '@syncfusion/ej2-circulargauge';

@Component({
imports: [
         CircularGaugeModule
    ],

providers: [AnnotationsService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-circulargauge id="circular-container" (loaded)='loaded!($event)'>
        <e-axes>
            <e-axis minimum=0 maximum=12 startAngle=0 endAngle=360 [lineStyle]="lineStyle" [labelStyle]="labelStyle">
                <e-annotations>
                    <e-annotation angle=270 radius='40%' zIndex='1'>
                    <ng-template #content>
                      <div id="subGauge" style="width:90px;height:90px"></div>
                    </ng-template>
                    </e-annotation>
                    <e-annotation angle=90 radius='40%' zIndex='1'>
                    <ng-template #content>
                      <div id="subTime" style="width:90px;height:90px">
                        <span>6:30 PM</span>
                      </div>
                    </ng-template>
                    </e-annotation>
                </e-annotations>
                <e-ranges>
                    <e-range start=0 end=3 color="rgba(29,29,29,0.7)"></e-range>
                    <e-range start=3 end=12 color="rgba(168,145,102,0.1)"></e-range>
                </e-ranges>
                <e-pointers>
                    <e-pointer pointerWidth=5 radius="40%" value=6.5 color="#1d1d1d" [border]='pointerBorder' [cap]='pointerCap' [needleTail]='pointerTail' [animation]='pointerAnimation'></e-pointer>
                    <e-pointer pointerWidth=5 radius="60%" value=6 color="#1d1d1d" [border]='pointerBorder' [cap]='pointerCap' [needleTail]='pointerTail' [animation]='pointerAnimation'></e-pointer>
                    <e-pointer pointerWidth=5 radius="70%" value=9.8 color="#a89166" [cap]='pointerCap1' [needleTail]='pointerTail1' [animation]='pointerAnimation'></e-pointer>
                </e-pointers>
            </e-axis>
        </e-axes>
    </ejs-circulargauge>`
})
export class AppComponent implements OnInit {
    public labelStyle?: Object;
    public lineStyle?: Object;
    public pointerBorder?: Object;
    public pointerCap?: Object;
    public pointerTail?: Object;
    public pointerAnimation?: Object;
    public pointerCap1?: Object;
    public pointerTail1?: Object;
    public loaded?: Function;
    ngOnInit(): void {
        // Initialize objects
        this.labelStyle = {
            hiddenLabel: 'First'
        };
        this.lineStyle = {
            width: 0
        };
        this.pointerBorder= { width: 1, color: 'rgb(29,29,29)' };
        this.pointerCap= {
            color: 'rgb(29,29,29)',
            radius: 0,
            border: {
                width: 0.2,
                color: 'red'
            }
        };
        this.pointerTail= {
            length: '0%'
        };
        this.pointerAnimation= {
            enable: false
        };
        this.pointerCap1= {
            color: 'rgba(168,145,102,1)',
            radius: 4,
            border: {
                width: 0.2,
                color: 'rgba(168,145,102,1)'
            }
        };
        this.pointerTail1= {
            color: 'rgba(168,145,102,1)',
            length: '20%'
        };
        this.loaded = (args: ILoadedEventArgs): void=> {
            let gauge: CircularGauge = new CircularGauge({
                axes: [{
                    minimum: 0,
                    maximum: 12,
                    startAngle: 0,
                    endAngle: 360,
                    majorTicks:{ interval: 3 },
                    lineStyle: { width: 0 },
                    ranges: [{
                        start: 0, end: 3,
                        startWidth: 5, endWidth: 5,
                        color: 'rgba(29,29,29,0.7)'
                    }, {
                        start: 3, end: 12,
                        startWidth: 5, endWidth: 5,
                        color: 'rgba(168,145,102,0.1)'
                    }],
                    labelStyle: {
                        hiddenLabel: 'First',
                        offset: -5
                    },
                    pointers: [{
                        pointerWidth: 2,
                        radius: '40%',
                        color: 'rgb(29,29,29)',
                        border: { width: 1, color: 'rgb(29,29,29)' },
                        cap: {
                            color: 'rgb(29,29,29)',
                            radius: 2,
                            border: {
                                width: 0.2,
                                color: 'red'
                            }
                        },
                        needleTail: {
                            length: '0%'
                        }, animation: {
                            enable: false
                        }
                    }]
                }]
            }, '#subGauge');
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

See also

Gauge annotations in React Circular gauge component

18 Nov 201824 minutes to read

Annotations are used to mark a specific area of interest in the gauge with texts, shapes or images.

Content

You can place any custom element on the axis area by assigning the id of the element to content property of annotation object.

Note: To use annotation feature, we need to inject Annotations module into the services.

import * as React from "react";
import { createRoot } from "react-dom/client";
import { CircularGaugeComponent, AxesDirective, AxisDirective, PointersDirective, PointerDirective, Inject, Annotations, AnnotationsDirective, AnnotationDirective } from '@syncfusion/ej2-react-circulargauge';

function App() {
  return (
    <CircularGaugeComponent>
      <Inject services={[Annotations]} />
      <AxesDirective>
        <AxisDirective>
          <PointersDirective>
            <PointerDirective value={50} />
          </PointersDirective>
          <AnnotationsDirective>
            <AnnotationDirective content='<div><div><span>Pointer Value : 50</span></div></div>' zIndex='1' />
          </AnnotationsDirective>
        </AxisDirective>
      </AxesDirective>
    </CircularGaugeComponent>
  );
}

const root = createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import { createRoot } from "react-dom/client";
import { CircularGaugeComponent, AxesDirective, AxisDirective, PointersDirective, PointerDirective, Inject, Annotations, AnnotationsDirective, AnnotationDirective } from '@syncfusion/ej2-react-circulargauge';

function App() {
  return (
    <CircularGaugeComponent>
      <Inject services={[Annotations]} />
      <AxesDirective>
        <AxisDirective>
          <PointersDirective>
            <PointerDirective value={50} />
          </PointersDirective>
          <AnnotationsDirective>
            <AnnotationDirective content='<div><div><span>Pointer Value : 50</span></div></div>' zIndex='1' />
          </AnnotationsDirective>
        </AxisDirective>
      </AxesDirective>
    </CircularGaugeComponent>
  );
}

const root = createRoot(document.getElementById('container')!);
root.render(<App />);

Position

Annotation can be placed around the axis by using radius
and angle property. For example, if the angle is 90 degree and the radius is 110%, then the annotation, will be placed at the right side of the axis.

Radius of the annotation takes value either in pixel or percentage. By setting value in percentage, annotation gets its position with respect to its axis radius.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { CircularGaugeComponent, AxesDirective, AxisDirective, PointersDirective, PointerDirective, Inject, Annotations, AnnotationsDirective, AnnotationDirective } from '@syncfusion/ej2-react-circulargauge';
export function App() {
return(
  <CircularGaugeComponent>
    <Inject services={[ Annotations ]}/>
    <AxesDirective>
      <AxisDirective>
        <PointersDirective>
            <PointerDirective value = {50}></PointerDirective>
        </PointersDirective>
        <AnnotationsDirective>
            <AnnotationDirective content='<div><div><span>Pointer Value : 50</span></div></div>' angle= {90} radius = '150%' zIndex='1'/>
        </AnnotationsDirective>
      </AxisDirective>
    </AxesDirective>
  </CircularGaugeComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { CircularGaugeComponent, AxesDirective, AxisDirective, PointersDirective, PointerDirective, Inject, Annotations, AnnotationsDirective, AnnotationDirective } from '@syncfusion/ej2-react-circulargauge';
export function App() {
return(
  <CircularGaugeComponent>
    <Inject services={[ Annotations ]}/>
    <AxesDirective>
      <AxisDirective>
        <PointersDirective>
            <PointerDirective value = {50}></PointerDirective>
        </PointersDirective>
        <AnnotationsDirective>
            <AnnotationDirective content='<div><div><span>Pointer Value : 50</span></div></div>' angle= {90} radius = '150%' zIndex='1'/>
        </AnnotationsDirective>
      </AxisDirective>
    </AxesDirective>
  </CircularGaugeComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Sub Gauge

As the annotation allows you to place any custom element, we can initialize a gauge to the element and can be used to place that in another gauge.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { CircularGaugeComponent, AxesDirective, AxisDirective, PointersDirective, PointerDirective, Inject, Annotations, AnnotationsDirective, AnnotationDirective, RangesDirective, RangeDirective } from '@syncfusion/ej2-react-circulargauge';
import { CircularGauge } from '@syncfusion/ej2-circulargauge';
export function App() {
   function loadRender(args) {
    new CircularGauge(
      {
        background: 'transparent',
        axes: [
          {
            minimum: 0,
            maximum: 12,
            startAngle: 0,
            endAngle: 360,
            majorTicks: { interval: 3 },
            lineStyle: { width: 0 },
            ranges: [
              {
                start: 0,
                end: 3,
                startWidth: 5,
                endWidth: 5,
                color: 'rgba(29,29,29,0.7)'
              },
              {
                start: 3,
                end: 12,
                startWidth: 5,
                endWidth: 5,
                color: 'rgba(168,145,102,0.1)'
              },
            ],
            labelStyle: { hiddenLabel: 'First', offset: -5 },
            pointers: [
              {
                pointerWidth: 2,
                radius: '40%',
                color: 'rgb(29,29,29)',
                border: { width: 1, color: 'rgb(29,29,29)' },
                cap: {
                  color: 'rgb(29,29,29)',
                  radius: 2,
                  border: { width: 0.2, color: 'red' }
                },
                needleTail: { length: '0%' },
                animation: { enable: false }
              }
            ]
          }
        ]
      },
      '#subGauge'
    );
   }
   return(
   <CircularGaugeComponent loaded= {loadRender}>
    <Inject services={[ Annotations ]}/>
    <AxesDirective>
      <AxisDirective  minimum= {0} maximum= {12} startAngle= {0} endAngle= {360} lineStyle= {{ width: 0 }} labelStyle = {{
            hiddenLabel: 'First'
        }}>
        <RangesDirective>
            <RangeDirective start={0} end={3} color='rgba(29,29,29,0.7)'></RangeDirective>
            <RangeDirective start={3} end={12} color='rgba(168,145,102,0.1)'></RangeDirective>
        </RangesDirective>
        <AnnotationsDirective>
            <AnnotationDirective content='<div id="subGauge" style="width:90px;height:90px;"></div>' angle= {270} radius = '40%' zIndex='1'/>
            <AnnotationDirective content='<div id="time"><span>6:30 PM</span></div>' angle= {90} radius = '40%' zIndex='1'/>
        </AnnotationsDirective>
        <PointersDirective>
            <PointerDirective pointerWidth= {5} radius= '40%' value= {6.5} color= 'rgb(29,29,29)' border = {{ width: 1, color: 'rgb(29,29,29)' }} cap = {{
                color: 'rgb(29,29,29)',
                radius: 0,
                border: {
                    width: 0.2,
                    color: 'red'
                }
            }} needleTail = {{
                length: '0%'
            }} animation = {{
                enable: false
            }}></PointerDirective>
            <PointerDirective radius= '60%' value = {6} pointerWidth= {5} color= 'rgb(29,29,29)'  border = {{
                width: 1,
                color: 'rgb(29,29,29)'
            }} cap = {{
                color: 'rgb(29,29,29)',
                radius: 0,
                border: {
                    width: 0.2,
                    color: 'red'
                }
            }} needleTail = {{
                length: '0%'
            }} animation = {{
                enable: false
            }}></PointerDirective>
            <PointerDirective radius= '70%' pointerWidth= {4} value= {9.8}
            color= 'rgba(168,145,102,1)' cap = {{
                color: 'rgba(168,145,102,1)',
                radius: 4,
                border: {
                    width: 0.2,
                    color: 'rgba(168,145,102,1)'
                }
            }} needleTail = {{
                color: 'rgba(168,145,102,1)',
                length: '20%'
            }} animation = {{
                enable: false,
                duration: 500
            }}></PointerDirective>
        </PointersDirective>
      </AxisDirective>
    </AxesDirective>
  </CircularGaugeComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { CircularGaugeComponent, AxesDirective, AxisDirective, PointersDirective, PointerDirective, Inject, Annotations, AnnotationsDirective, AnnotationDirective, RangesDirective, RangeDirective, ILoadedEventArgs } from '@syncfusion/ej2-react-circulargauge';
import { CircularGauge } from '@syncfusion/ej2-circulargauge';
export function App() {
   function loadRender(args: ILoadedEventArgs) {
    new CircularGauge(
      {
        background: 'transparent',
        axes: [
          {
            minimum: 0,
            maximum: 12,
            startAngle: 0,
            endAngle: 360,
            majorTicks: { interval: 3 },
            lineStyle: { width: 0 },
            ranges: [
              {
                start: 0,
                end: 3,
                startWidth: 5,
                endWidth: 5,
                color: 'rgba(29,29,29,0.7)'
              },
              {
                start: 3,
                end: 12,
                startWidth: 5,
                endWidth: 5,
                color: 'rgba(168,145,102,0.1)'
              },
            ],
            labelStyle: { hiddenLabel: 'First', offset: -5 },
            pointers: [
              {
                pointerWidth: 2,
                radius: '40%',
                color: 'rgb(29,29,29)',
                border: { width: 1, color: 'rgb(29,29,29)' },
                cap: {
                  color: 'rgb(29,29,29)',
                  radius: 2,
                  border: { width: 0.2, color: 'red' }
                },
                needleTail: { length: '0%' },
                animation: { enable: false }
              }
            ]
          }
        ]
      },
      '#subGauge'
    );
   }
   return(
   <CircularGaugeComponent loaded= {loadRender}>
    <Inject services={[ Annotations ]}/>
    <AxesDirective>
      <AxisDirective  minimum= {0} maximum= {12} startAngle= {0} endAngle= {360} lineStyle= {{ width: 0 }} labelStyle = {{
            hiddenLabel: 'First'
        }}>
        <RangesDirective>
            <RangeDirective start={0} end={3} color='rgba(29,29,29,0.7)'></RangeDirective>
            <RangeDirective start={3} end={12} color='rgba(168,145,102,0.1)'></RangeDirective>
        </RangesDirective>
        <AnnotationsDirective>
            <AnnotationDirective content='<div id="subGauge" style="width:90px;height:90px;"></div>' angle= {270} radius = '40%' zIndex='1'/>
            <AnnotationDirective content='<div id="time"><span>6:30 PM</span></div>' angle= {90} radius = '40%' zIndex='1'/>
        </AnnotationsDirective>
        <PointersDirective>
            <PointerDirective pointerWidth= {5} radius= '40%' value= {6.5} color= 'rgb(29,29,29)' border = {{ width: 1, color: 'rgb(29,29,29)' }} cap = {{
                color: 'rgb(29,29,29)',
                radius: 0,
                border: {
                    width: 0.2,
                    color: 'red'
                }
            }} needleTail = {{
                length: '0%'
            }} animation = {{
                enable: false
            }}></PointerDirective>
            <PointerDirective radius= '60%' value = {6} pointerWidth= {5} color= 'rgb(29,29,29)'  border = {{
                width: 1,
                color: 'rgb(29,29,29)'
            }} cap = {{
                color: 'rgb(29,29,29)',
                radius: 0,
                border: {
                    width: 0.2,
                    color: 'red'
                }
            }} needleTail = {{
                length: '0%'
            }} animation = {{
                enable: false
            }}></PointerDirective>
            <PointerDirective radius= '70%' pointerWidth= {4} value= {9.8}
            color= 'rgba(168,145,102,1)' cap = {{
                color: 'rgba(168,145,102,1)',
                radius: 4,
                border: {
                    width: 0.2,
                    color: 'rgba(168,145,102,1)'
                }
            }} needleTail = {{
                color: 'rgba(168,145,102,1)',
                length: '20%'
            }} animation = {{
                enable: false,
                duration: 500
            }}></PointerDirective>
        </PointersDirective>
      </AxisDirective>
    </AxesDirective>
  </CircularGaugeComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

See also